'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII  DEMO ZUM BASIC-COMPUTER UNIT MICRO    (by DIE HARD)  IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'--------------------------------------------------------------------
' Beispiel zum BASIC-COMPUTER  mit dem Programmer/Application-Board
'--------------------------------------------------------------------
' ANWENDUNG:   ZUBEHR IR SENDE/EMPFANGSMODUL 198860 oder TSOP1836
'              IR-COMMUNICATIONS DRIVER

'--------------------------------------------------------------------
' Dieses Beispiel zeigt die Vorgehensweise fr die Benutzung des IR
' Treibers (RC5 codiert) im Betriebssystem, zusammen mit
' dem als Zubehr erhltlichen SENDE/EMPFANGSMODUL oder mit einem
' IR Empfngerbaustein TSOP 1838
' Das IR SENDE/EMPFANGSMODUL 198860 knnen Sie verwenden wenn sie
' Die MICRO mit einem MICRO-MODUL am Applicationboard 2.0 betreiben.
' Dazu muss der PORT4 der UNIT mit PORT2 auf der BUSLEISTE des Application
' Boards verbunden sein.
' Ausserdem ist zur Anzeige ein IIC-BUS LCD erfoderlich, wenn sie kein
' MICRO-MODUL verwenden.
' Das MICRO-MODUL ermglicht es das LCD am Applicationboard zur Anzeige zu
' verwenden. Der erforderliche Portbaustein PCF8574 befindet sich auf
' diesem Modul.
'--------------------------------------------------------------------
' Das RC5 Format wird von den meisten Gerten der Unterhaltungsindustrie
' verwendetund ermglicht es Ihnen diese Gerte mit dem BASIC-Computer
' zu steuern. Das RC5 Format besteht aus einer Gerteadresse und einem
' Kommando. Das IR-MODULE erwartet zwei PUT Anweisungen (jeweils
' die Adresse, danach das Kommando)und sendet dann den entsprechenden
' Datenrahmen. Empfangene Daten werden mit jeweils zwei GET Anweisungen
' abgerufen
'
' RC5 FORMAT:
'    13-12-11-10-09-08-07-06-05-04-03-02-01-00   DATA BIT
'     S  S  T a4 a3 a2 a1 a0 c5 c4 c3 c2 c1 c0   RC5
'
' Der Teiber untersttzt den IR Datensender allerdings nicht, sodass
' nur Empfang mglich ist.

' Beschreibung:
' Das Programm wartet auf einen empfangenen IR-Code.
' Wird ein Code empfangen, so wird der Empfangene Code am LCD angezeigt.
' Es wurde nichts empfangen, oder der Empfangsbuffer ist bereits geleert,
' wenn der Inhalt von ADDR und CMD jeweils 255 ist.
'-----------------------------------------------------------------------

'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[2]
define SCL      port[5]
'---- IR RECCEIER ---------
define IRIN      port[4]

'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
define COMMAND   byte[1]
define ADDRESS   byte[2]
'--- IIC INTERFACE  -------
define IICDATA      byte[3]
define DB0         bit[17]
define DB1         bit[18]
define DB2         bit[19]
define DB3         bit[20]
define DB4         bit[21]
define DB5         bit[22]
define DB6         bit[23]
define DB7         bit[24]
'--------------------------
define OUTBYTE      byte[4]
define LCDDATA      byte[5]
define BUF          byte[6]
define WADDRESS     byte[7]


'--- DEZIMAL CONVERTER ----
define value         byte[8]
define zehner        byte[9]
define einer         byte[10]

define LCDADDR  &B01001110

'---- ZEICHENSATZ DEFINITION -------------
define Z0&H30:define Z1&H31:define Z2&H32:define Z3&H33
define Z4&H34:define Z5&H35:define Z6&H36:define Z7&H37
define Z8&H38:define Z9&H39
define A&H41:define B&H42:define C&H43:define D&H44
define E&H45:define F&H46:define G&H47:define H&H48
define I&H49:define J&H4A:define K&H4B:define L&H4C
define M&H4D:define N&H4E:define O&H4F:define P&H50
define Q&H51:define R&H52:define S&H53:define T&H54
define U&H55:define V&H56:define W&H57:define X&H58
define Y&H59:define Z&H5A:define BLK&H20

'---------- IICBUS INIT ------------------
SDA=on:SCL=on
'---- PCF8574 LCD DRIVE INIT -------------
gosub lcd_init
'------ IR BACKGROUND RECEIVING INIT -----
SYS &HFD06
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II          ANZEIGE IR-CODES                 II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
pause 20
gosub LCD_CLR
LCDDATA=W:gosub lcd_writechar
LCDDATA=A:gosub lcd_writechar
LCDDATA=I:gosub lcd_writechar
LCDDATA=T:gosub lcd_writechar
LCDDATA=I:gosub lcd_writechar
LCDDATA=N:gosub lcd_writechar
LCDDATA=G:gosub lcd_writechar



#loop
gosub CLEAR_DATA
'----- WAITING FOR RECEIVED DATA -------
wait (COMMAND or ADDRESS)<>0
'----- DELETE TOGGLE BIT ---------------
ADDRESS=ADDRESS and &H1F
'-------------- SHOW RESULT --------------------
gosub LCD_CLR
LCDDATA=A:gosub lcd_writechar
LCDDATA=D:gosub lcd_writechar
LCDDATA=R:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
value=ADDRESS:gosub SHOW
LCDDATA=BLK:gosub lcd_writechar
LCDDATA=C:gosub lcd_writechar
LCDDATA=M:gosub lcd_writechar
LCDDATA=D:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
value=COMMAND:gosub SHOW
pause 10:gosub LCD_CLR:goto LOOP
'----------------------------------------------



'IIIIIIIIIIIII UNTERPROGRAMME IIIIIIIIIIIIIIIIIIIIIII
#SHOW
zehner=value/10:LCDDATA=zehner+&H30:gosub LCD_WRITECHAR
einer=value-(zehner*10):LCDDATA=einer+&H30:gosub LCD_WRITECHAR
return
'---------------------------------------
#CLEAR_DATA
COMMAND=0:ADDRESS=0:return
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII



'-------------------------------------------
'-- WRITE BYTE IN OUTBYTE TO PCF8574  ------
'-------------------------------------------
#WRITEBYTE
gosub IICSTART:IICDATA=WADDRESS:gosub IICSEND
IICDATA=OUTBYTE:gosub IICSEND:gosub IICSTOP:return
'-------------------------------------------
#IICSTART
SDA=off:SCL=off:return
#IICSTOP
SDA=off:SCL=on:SDA=on:return
#IICSEND
SDA=DB7:SCL=on:SCL=off
SDA=DB6:SCL=on:SCL=off
SDA=DB5:SCL=on:SCL=off
SDA=DB4:SCL=on:SCL=off
SDA=DB3:SCL=on:SCL=off
SDA=DB2:SCL=on:SCL=off
SDA=DB1:SCL=on:SCL=off
SDA=DB0:SCL=on:SCL=off
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
deact SDA:SCL=on:SCL=off:SDA=off:return

'---------------------------------------
'------------- LCD ROUTINES -------------
'----------------------------------------
#LCD_INIT
WADDRESS=LCDADDR
OUTBYTE=0:gosub WRITEBYTE
LCDDATA=&H38:gosub LCD_WRITECMD
OUTBYTE= &B00000010:gosub WRITEBYTE '$02 to LCD
OUTBYTE= &B01000010:gosub WRITEBYTE '$02 with CLOCK
OUTBYTE= &B00000010:gosub WRITEBYTE
LCDDATA=&H28:gosub LCD_WRITECMD
LCDDATA=&H0C:gosub LCD_WRITECMD
#LCD_CLR
LCDDATA=&H02:gosub LCD_WRITECMD
LCDDATA=&H01:gosub LCD_WRITECMD
return
#L1_GOTOPOS
LCDDATA=LCDDATA +&H7F:goto LCD_WRITECMD
#L2_GOTOPOS
LCDDATA=LCDDATA +&HBF:goto LCD_WRITECMD
#LCD_WRITECMD
BUF = off:goto LCD_WRITE
#LCD_WRITECHAR
BUF = &B00100000
#LCD_WRITE
WADDRESS=LCDADDR
'--------- WRITE HI NIBBLE -------------
OUTBYTE=BUF or (LCDDATA shr 4):gosub WRITEBYTE      'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
'--------- WRITE LO NIBBLE -------------
OUTBYTE=BUF or (LCDDATA and &H0F):gosub WRITEBYTE'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
return

SYSCODE "RC5_P0.s19"
