'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIIIIIIIIIII      TOOL ZUR C-CONTROL MICRO             IIIIIIIIIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'(by DIE HARD  10.04)
'
'-----------------------------------------------------------------------
' Beschreibung
' Ein kleines TOOL um die OS Version der MICRO zu lesen. Die Version
' steht nach dem Einschalten in der Variablen Byte[24]
' Der Inhalt 01 steht z.B. fr OS V 2.01
' Die Ausgabe erfolgt auf ein LCD, angeschlossen an einen PCF 8574
' auf Adresse &B01001110
' Wenn Sie dieses Programm zusammen mit dem MICRO-MODUL und dem Application
' Board 2.0 benutzen, erfolgt die Ausgabe auf das LCD des Application-Board
' 
' Zustzlich blinkt LED4 um die Version auch zu identifizieren, wenn sie
' kein LCD haben
' Eine Version 2.03 blinkt z.B. 3 mal und wiederholt das Blinken nach
' kurzer Pause.
'-------------------------------------------------------------------
'Hier sehen Sie, welche PCF 8574 Ports dem LCD zugeordnet sind:
'Port 0  LCD DB4
'Port 1  LCD DB5
'Port 2  LCD DB6
'Port 3  LCD DB7
'Port 4  LCD R/W
'Port 5  LCD RS
'Port 6  LCD EN
'-------------------------------------------------------------------
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------
define SDA      port[5]
define SCL      port[6]
define LED      port[4]
'--------------------------
'------ SYSTEM MEMORY -----
'--------------------------
'--- IIC INTERFACE  -------
define IICDATA      byte[1]
define OUTBYTE      byte[2]
define LCDDATA      byte[3]
define BUF          byte[4]
define WADDRESS     byte[5]
'--- PROGRAMM       -------
define VERSION      byte[24]
define COUNTER      byte[6]
'--- DEZIMAL CONVERTER ----
define value         byte[7]
define zehner        byte[8]
define einer         byte[9]

define LCDADDR  &B01001110

'---- ZEICHENSATZ DEFINITION -------------
define Z0&H30:define Z1&H31:define Z2&H32:define Z3&H33
define Z4&H34:define Z5&H35:define Z6&H36:define Z7&H37
define Z8&H38:define Z9&H39
define A&H41:define B&H42:define C&H43:define D&H44
define E&H45:define F&H46:define G&H47:define H&H48
define I&H49:define J&H4A:define K&H4B:define L&H4C
define M&H4D:define N&H4E:define O&H4F:define P&H50
define Q&H51:define R&H52:define S&H53:define T&H54
define U&H55:define V&H56:define W&H57:define X&H58
define Y&H59:define Z&H5A:define BLK&H20

'---------- IICBUS INIT ------------------
SDA=on:SCL=on

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'II      AUSLESEN DER OS VERSION              II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
pause 20
'---- PCF8574 DEVICE WRITE ADDRESS -------------
gosub lcd_init

'-------------- SHOW RESULT --------------------
LCDDATA=3:gosub L1_GOTOPOS    'LINE 1 POS 4
LCDDATA=V:gosub lcd_writechar
LCDDATA=E:gosub lcd_writechar
LCDDATA=R:gosub lcd_writechar
LCDDATA=S:gosub lcd_writechar
LCDDATA=I:gosub lcd_writechar
LCDDATA=O:gosub lcd_writechar
LCDDATA=N:gosub lcd_writechar
LCDDATA=BLK:gosub lcd_writechar
value=VERSION:gosub SHOW
'----------------------------------------------
#LOOP
if VERSION =0 then goto LOOP
for COUNTER= 1 to VERSION
LED=on:pause 5:LED=off:pause 20
next
pause 50:goto LOOP


'IIIIIIIIIIIII UNTERPROGRAMME IIIIIIIIIIIIIIIIIIIIIII
#SHOW
LCDDATA=&H32:gosub LCD_WRITECHAR:LCDDATA=&H2E:gosub LCD_WRITECHAR
zehner=value/10:LCDDATA=zehner+&H30:gosub LCD_WRITECHAR
einer=value-(zehner*10):LCDDATA=einer+&H30:gosub LCD_WRITECHAR
return
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII



'-------------------------------------------
'-- WRITE BYTE IN OUTBYTE TO PCF8574  ------
'-------------------------------------------
#WRITEBYTE
gosub IICSTART:IICDATA=WADDRESS:gosub IICSEND
IICDATA=OUTBYTE:gosub IICSEND:gosub IICSTOP:return
'-------------------------------------------
#IICSTART
SDA=off:SCL=off:return
#IICSTOP
SDA=off:SCL=on:SDA=on:return
#IICSEND
SDA=(IICDATA and &H80)shr 7:SCL=on:SCL=off
SDA=(IICDATA and &H40)shr 6:SCL=on:SCL=off
SDA=(IICDATA and &H20)shr 5:SCL=on:SCL=off
SDA=(IICDATA and &H10)shr 4:SCL=on:SCL=off
SDA=(IICDATA and &H08)shr 3:SCL=on:SCL=off
SDA=(IICDATA and &H04)shr 2:SCL=on:SCL=off
SDA=(IICDATA and &H02)shr 1:SCL=on:SCL=off
SDA=(IICDATA and &H01):SCL=on:SCL=off
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
deact SDA:SCL=on:SCL=off:SDA=off:return

'---------------------------------------
'------------- LCD ROUTINES -------------
'----------------------------------------
#LCD_INIT
WADDRESS=LCDADDR
OUTBYTE=0:gosub WRITEBYTE
LCDDATA=&H38:gosub LCD_WRITECMD
OUTBYTE= &B00000010:gosub WRITEBYTE '$02 to LCD
OUTBYTE= &B01000010:gosub WRITEBYTE '$02 with CLOCK
OUTBYTE= &B00000010:gosub WRITEBYTE
LCDDATA=&H28:gosub LCD_WRITECMD
LCDDATA=&H0C:gosub LCD_WRITECMD
#LCD_CLR
LCDDATA=&H02:gosub LCD_WRITECMD
LCDDATA=&H01:gosub LCD_WRITECMD
return
#L1_GOTOPOS
LCDDATA=LCDDATA +&H7F:goto LCD_WRITECMD
#L2_GOTOPOS
LCDDATA=LCDDATA +&HBF:goto LCD_WRITECMD
#LCD_WRITECMD
BUF = off:goto LCD_WRITE
#LCD_WRITECHAR
BUF = &B00100000
#LCD_WRITE
WADDRESS=LCDADDR
'--------- WRITE HI NIBBLE -------------
OUTBYTE=BUF or (LCDDATA shr 4):gosub WRITEBYTE      'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
'--------- WRITE LO NIBBLE -------------
OUTBYTE=BUF or (LCDDATA and &H0F):gosub WRITEBYTE'DATA TO PORT
OUTBYTE=OUTBYTE or &B01000000:gosub WRITEBYTE           'STROBE HI
OUTBYTE=OUTBYTE and &B10111111:gosub WRITEBYTE          'STROBE LO
return


